## wxTopLevelWindow

wxTopLevelWindow is a common base class for wxDialog and wxFrame. It is an abstract base class meaning that you never work with objects of this class directly, but all of its methods are also applicable for the two classes above.

Derived from

wxWindow
wxEvtHandler
wxObject

Include files

<wx/toplevel.h>

Members

wxTopLevelWindow::GetIcon
wxTopLevelWindow::GetIcons
wxTopLevelWindow::GetTitle
wxTopLevelWindow::IsActive
wxTopLevelWindow::Iconize
wxTopLevelWindow::IsFullScreen
wxTopLevelWindow::IsIconized
wxTopLevelWindow::IsMaximized
wxTopLevelWindow::Maximize
wxTopLevelWindow::RequestUserAttention
wxTopLevelWindow::SetIcon
wxTopLevelWindow::SetIcons
wxTopLevelWindow::SetLeftMenu
wxTopLevelWindow::SetRightMenu
wxTopLevelWindow::SetShape
wxTopLevelWindow::SetTitle
wxTopLevelWindow::ShowFullScreen

### wxTopLevelWindow::GetIcon

const wxIcon& GetIcon() const

Returns the standard icon of the window. The icon will be invalid if it hadn't been previously set by SetIcon.

See also

GetIcons

### wxTopLevelWindow::GetIcons

const wxIconBundle& GetIcons() const

Returns all icons associated with the window, there will be none of them if neither SetIcon nor SetIcons had been called before.

Use GetIcon to get the main icon of the window.

See also

wxIconBundle

### wxTopLevelWindow::GetTitle

wxString GetTitle() const

Gets a string containing the window title.

See wxTopLevelWindow::SetTitle.

### wxTopLevelWindow::IsActive

bool IsActive() const

Returns `true` if this window is currently active, i.e. if the user is currently working with it.

### wxTopLevelWindow::Iconize

void Iconize(bool iconize)

Iconizes or restores the window.

Parameters

iconize

If `true`, iconizes the window; if `false`, shows and restores it.

See also

wxTopLevelWindow::IsIconized, wxTopLevelWindow::Maximize.

### wxTopLevelWindow::IsFullScreen

bool IsFullScreen()

Returns `true` if the window is in fullscreen mode.

See also

wxTopLevelWindow::ShowFullScreen

### wxTopLevelWindow::IsIconized

bool IsIconized() const

Returns `true` if the window is iconized.

### wxTopLevelWindow::IsMaximized

bool IsMaximized() const

Returns `true` if the window is maximized.

### wxTopLevelWindow::Maximize

void Maximize(bool maximize)

Maximizes or restores the window.

Parameters

maximize

If `true`, maximizes the window, otherwise it restores it.

Remarks

This function only works under Windows.

See also

wxTopLevelWindow::Iconize

### wxTopLevelWindow::RequestUserAttention

void RequestUserAttention(int flags = wxUSER_ATTENTION_INFO)

Use a system-dependent way to attract users attention to the window when it is in background.

flags may have the value of either `wxUSER_ATTENTION_INFO` (default) or `wxUSER_ATTENTION_ERROR` which results in a more drastic action. When in doubt, use the default value.

Note that this function should normally be only used when the application is not already in foreground.

This function is currently only implemented for Win32 where it flashes the window icon in the taskbar.

### wxTopLevelWindow::SetIcon

void SetIcon(const wxIcon& icon)

Sets the icon for this window.

Parameters

icon

The icon to associate with this window.

Remarks

The window takes a 'copy' of icon, but since it uses reference counting, the copy is very quick. It is safe to delete icon after calling this function.

See also wxIcon.

### wxTopLevelWindow::SetIcons

void SetIcons(const wxIconBundle& icons)

Sets several icons of different sizes for this window: this allows to use different icons for different situations (e.g. task switching bar, taskbar, window title bar) instead of scaling, with possibly bad looking results, the only icon set by SetIcon.

Parameters

icons

The icons to associate with this window.

See also

wxIconBundle.

### wxTopLevelWindow::SetLeftMenu

void SetLeftMenu(int id = wxID_ANY, const wxString& label = wxEmptyString, wxMenu * subMenu = NULL)

Sets action or menu activated by pressing left hardware button on the smart phones. Unavailable on full keyboard machines.

Parameters

id

Identifier for this button.

label

Text to be displayed on the screen area dedicated to this hardware button.

subMenu

The menu to be opened after pressing this hardware button.

See also

wxTopLevelWindow::SetRightMenu.

### wxTopLevelWindow::SetRightMenu

void SetRightMenu(int id = wxID_ANY, const wxString& label = wxEmptyString, wxMenu * subMenu = NULL)

Sets action or menu activated by pressing right hardware button on the smart phones. Unavailable on full keyboard machines.

Parameters

id

Identifier for this button.

label

Text to be displayed on the screen area dedicated to this hardware button.

subMenu

The menu to be opened after pressing this hardware button.

See also

wxTopLevelWindow::SetLeftMenu.

### wxTopLevelWindow::SetShape

bool SetShape(const wxRegion& region)

If the platform supports it, sets the shape of the window to that depicted by region. The system will not display or respond to any mouse event for the pixels that lie outside of the region. To reset the window to the normal rectangular shape simply call SetShape again with an empty region. Returns TRUE if the operation is successful.

### wxTopLevelWindow::SetTitle

virtual void SetTitle(const wxString& title)

Sets the window title.

Parameters

title

The window title.

See also

wxTopLevelWindow::GetTitle

### wxTopLevelWindow::ShowFullScreen

bool ShowFullScreen(bool show, long style = wxFULLSCREEN_ALL)

Depending on the value of show parameter the window is either shown full screen or restored to its normal state. style is a bit list containing some or all of the following values, which indicate what elements of the window to hide in full-screen mode:

- wxFULLSCREEN_NOMENUBAR
- wxFULLSCREEN_NOTOOLBAR
- wxFULLSCREEN_NOSTATUSBAR
- wxFULLSCREEN_NOBORDER
- wxFULLSCREEN_NOCAPTION
- wxFULLSCREEN_ALL (all of the above)

This function has not been tested with MDI frames.

Note that showing a window full screen also actually Show()s if it hadn't been shown yet.

See also

wxTopLevelWindow::IsFullScreen